package cn.iocoder.yudao.module.iot.service.frpc;

import cn.iocoder.yudao.framework.common.pojo.PageResult;
import cn.iocoder.yudao.framework.common.util.object.BeanUtils;
import cn.iocoder.yudao.module.iot.controller.admin.frpc.vo.FrpcProxyServerPageReqVO;
import cn.iocoder.yudao.module.iot.controller.admin.frpc.vo.FrpcProxyServerSaveReqVO;
import cn.iocoder.yudao.module.iot.dal.dataobject.frpc.FrpcProxyServerDO;
import cn.iocoder.yudao.module.iot.dal.mysql.frpc.FrpcProxyServerMapper;
import org.springframework.stereotype.Service;
import org.springframework.validation.annotation.Validated;

import javax.annotation.Resource;

import static cn.iocoder.yudao.framework.common.exception.util.ServiceExceptionUtil.exception;
import static cn.iocoder.yudao.module.iot.enums.ErrorCodeConstants.FRPC_PROXY_SERVER_NOT_EXISTS;

/**
 * 代理服务 Service 实现类
 *
 * @author 内蒙必硕
 */
@Service
@Validated
public class FrpcProxyServerServiceImpl implements FrpcProxyServerService {

    @Resource
    private FrpcProxyServerMapper frpcProxyServerMapper;

    @Override
    public Long createFrpcProxyServer(FrpcProxyServerSaveReqVO createReqVO) {
        // 插入
        FrpcProxyServerDO frpcProxyServer = BeanUtils.toBean(createReqVO, FrpcProxyServerDO.class);
        frpcProxyServerMapper.insert(frpcProxyServer);
        // 返回
        return frpcProxyServer.getId();
    }

    @Override
    public void updateFrpcProxyServer(FrpcProxyServerSaveReqVO updateReqVO) {
        // 校验存在
        validateFrpcProxyServerExists(updateReqVO.getId());
        // 更新
        FrpcProxyServerDO updateObj = BeanUtils.toBean(updateReqVO, FrpcProxyServerDO.class);
        frpcProxyServerMapper.updateById(updateObj);
    }

    @Override
    public void deleteFrpcProxyServer(Long id) {
        // 校验存在
        validateFrpcProxyServerExists(id);
        // 删除
        frpcProxyServerMapper.deleteById(id);
    }

    private void validateFrpcProxyServerExists(Long id) {
        if (frpcProxyServerMapper.selectById(id) == null) {
            throw exception(FRPC_PROXY_SERVER_NOT_EXISTS);
        }
    }

    @Override
    public FrpcProxyServerDO getFrpcProxyServer(Long id) {
        return frpcProxyServerMapper.selectById(id);
    }

    @Override
    public PageResult<FrpcProxyServerDO> getFrpcProxyServerPage(FrpcProxyServerPageReqVO pageReqVO) {
        return frpcProxyServerMapper.selectPage(pageReqVO);
    }

}